IMovieDb/Controllers/MovieController.cs
using Core_2._2.Mappers.Contracts;
using Core_2._2.Models;
using IMovieDb.Data.Models;
using IMovieDb.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using MovieDb.Data.Models;
using MovieDb.Services.Contracts;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace IMovieDb.Controllers
{
    public class MovieController : Controller
    {
        private readonly IMovieService movieService;
        private readonly IDirectorService directorService;
        private readonly IActorService actorService;
        private readonly IGenreService genreService;
        private readonly IPreviewService previewService;
        private readonly IViewModelMapper<Movie, MovieViewModel> movieMapper;
        private readonly IViewModelMapper<IReadOnlyCollection<Movie>, MoviesViewModel> moviesMapper;
        private readonly IViewModelMapper<IReadOnlyCollection<Movie>, SearchViewModel> searchMapper;

        public MovieController(IMovieService movieService, IDirectorService directorService, IActorService actorService,  
            IViewModelMapper<IReadOnlyCollection<Movie>, MoviesViewModel> moviesMapper, IGenreService genreService,
            IPreviewService previewService, IViewModelMapper<Movie, MovieViewModel> movieMapper,
            IViewModelMapper<IReadOnlyCollection<Movie>, SearchViewModel> searchMapper)
        {
            this.movieMapper = movieMapper ?? throw new ArgumentNullException(nameof(movieMapper));
            this.movieService = movieService ?? throw new ArgumentNullException(nameof(movieService));
            this.directorService = directorService ?? throw new ArgumentNullException(nameof(directorService));
            this.actorService = actorService ?? throw new ArgumentNullException(nameof(actorService));
            this.genreService = genreService ?? throw new ArgumentNullException(nameof(genreService));
            this.previewService = previewService ?? throw new ArgumentNullException(nameof(previewService));
            this.moviesMapper = moviesMapper ?? throw new ArgumentNullException(nameof(moviesMapper));
            this.searchMapper = searchMapper ?? throw new ArgumentNullException(nameof(searchMapper));
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddMovie()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddMovie(MovieViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var movie = await this.movieService.AddMovieAsync(model.Title, model.ReleaseDate, model.Duration);

            if (model.MovieGenres != null)
            {
                foreach (var item in model.MovieGenres)
                {
                    var genre = await this.genreService.AddGenreAsync(model.Title, item);
                }
            }

            if (model.Director?.FirstName != null && model.Director?.LastName != null)
            {
                var director = await this.directorService.AddDirectorAsync(model.Title, model.Director.FirstName, model.Director.LastName);
            }

            if (model.Rating != null)
            {
                movie = await this.movieService.AddRatingAsync(model.Title, (int) model.Rating);
            }

            if (model.Preview?.Content != null)
            {
                var preview = await this.previewService.AddPreviewAsync(model.Title, model.Preview.Content);
            }

            if (model.Actors != null)
            {
                foreach (var item in model.Actors)
                {
                    if (item.FirstName != null && item.LastName != null)
                    {
                        var actor = await this.actorService.AddActorAsync(model.Title, item.FirstName, item.LastName, item.Birthday);
                    }
                }
            }

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddDirector()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddDirector(DirectorViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var director = await this.directorService.AddDirectorAsync(model.MovieTitle, model.FirstName, model.LastName);

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddActors()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddActors(ActorsViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var actor = await this.actorService.AddActorAsync(model.MovieTitle, model.FirstName, model.LastName, model.Birthday);

            foreach (var item in model.Actors)
            {
                if (item.FirstName != null && item.LastName != null)
                {
                    actor = await this.actorService.AddActorAsync(model.MovieTitle, item.FirstName, item.LastName, item.Birthday);
                }
            }

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddPreview()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddPreview(PreviewViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var preview = await this.previewService.AddPreviewAsync(model.MovieTitle, model.Content);

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddRating()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddRating(RatingViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var movie = await this.movieService.AddRatingAsync(model.MovieTitle, model.Rating);

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddGenres()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddGenres(GenresViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            foreach (var item in model.Genres)
            {
                var genre = await this.genreService.AddGenreAsync(model.MovieTitle, item);
            }

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult DeleteGenres()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteGenres(GenresViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            foreach (var item in model.Genres)
            {
                await this.genreService.DeleteGenreAsync(model.MovieTitle, item);
            }

            return RedirectToAction("Index", "Home");
        }


        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddMainGenres()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddMainGenres(MainGenresViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            foreach (var item in model.MainGenres)
            {
                var genre = await this.genreService.AddMainGenreAsync(item);
            }

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult ChangePreview()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ChangePreview(PreviewViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var preview = await this.previewService.ChangePreviewAsync(model.MovieTitle, model.Content);

            return RedirectToAction("Index", "Home");
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult ChangeRating()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ChangeRating(RatingViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var (movie, oldRating) = await this.movieService.ChangeRatingAsync(model.MovieTitle, model.Rating);

IMovieDb/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - IMovieDb</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
</head>
<body>
    <nav class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand">IMovieDb</a>
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                    <li class="dropdown">
                        <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Movies<span class="caret"></span></a>
                        <ul class="dropdown-menu">
                            <li><a asp-area="" asp-controller="Movie" asp-action="ShowMoviesByActor">Show Movies by Actor</a></li>
                            <li><a asp-area="" asp-controller="Movie" asp-action="ShowMoviesByDirector">Show Movies by Director</a></li>
                            <li><a asp-area="" asp-controller="Movie" asp-action="ShowMoviesByGenre">Show Movies by Genre</a></li>
                            <li><a asp-area="" asp-controller="Movie" asp-action="ShowMoviesByMainGenre">Show Movies by Main Genre</a></li>
                            <li><a asp-area="" asp-controller="Movie" asp-action="ShowMoviesByReleaseYear">Show Movies by Release Year</a></li>
                            <li><a asp-area="" asp-controller="Movie" asp-action="ShowMoviesByReleaseDate">Show Movies by Release Date</a></li>

                        </ul>
                    </li>
                    <li><a asp-area="" asp-controller="Movie" asp-action="Search">Search</a></li>
                    @if (User.IsInRole("Admin"))
                    {
                        <li class="dropdown">
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Administration<span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddMovie">Add Movie</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddDirector">Add Movie Director</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddActors">Add Movie Actors</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddPreview">Add Movie Preview</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddRating">Add Movie Rating</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddGenres">Add Movie Genres</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="AddMainGenres">Add Main Genres</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="ChangePreview">Change Movie Preview</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="ChangeRating">Change Movie Rating</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="DeleteMovie">Delete Movie</a></li>
                                <li><a asp-area="" asp-controller="Movie" asp-action="DeleteGenres">Delete Movie Genres</a></li>
                            </ul>
                        </li>
                    }
                </ul>
                @await Html.PartialAsync("_LoginPartial")
            </div>
        </div>
    </nav>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; 2019 - IMovieDb</p>
        </footer>
    </div>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-2.2.0.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-K+ctZQ+LL8q6tP7I94W+qzQsfRV2a+AfHIi9k8z8l9ggpc8X+Ytst4yBo/hH+8Fk">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("Scripts", required: false)
</body>
</html>

IMovieDb/Views/Shared/_ShowAllMoviesPartial.cshtml
@model MoviesViewModel
@{
    ViewData["Title"] = "ShowAllMovies";
}

<h3></h3>
<table class="table table-hover" id="forumIndexTable">

    <tbody>
        @foreach (var movie in Model.Movies)
        {
            <tr>
                <td>
                    <img src="@movie.ImageURL" alt="" width="150">
                </td>
                <td>
                    <a asp-controller="Movie" asp-action="Details" asp-route-id="@movie.Id">
                        <h3><strong>@movie.Title</strong></h3>
                    </a>
                    @if (movie.Rating == null)
                    {
                        <p><strong>Title:</strong> @movie.Title</p>
                        <p><strong>Release Date:</strong> @movie.ReleaseDate.ToString("dd MMMM yyyy")</p>
                        <p><strong>Duration:</strong> @movie.Duration min</p>
                    }
                    else
                    {
                        <p><strong>Title:</strong> @movie.Title</p>
                        <p><strong>Release Date:</strong> @movie.ReleaseDate.ToString("dd MMMM yyyy")</p>
                        <p><strong>Duration:</strong> @movie.Duration min</p>
                        <p><strong>IMovieDb rating:</strong> @movie.Rating</p>
                    }
                </td>
            </tr>
        }
    </tbody>
</table>